---
title: BaseAudioContext.createIIRFilter()
slug: Web/API/BaseAudioContext/createIIRFilter
tags:
  - API
  - Audio
  - AudioContext
  - BaseAudioContext
  - CreateIIRFilter
  - Method
  - Reference
  - Web Audio API
  - filter
---
<p>{{ APIRef("Web Audio API") }}</p>

<p>The <strong><code>createIIRFilter()</code></strong> method of the {{ domxref("BaseAudioContext") }} interface creates an {{ domxref("IIRFilterNode") }}, which represents a general <strong>{{interwiki("wikipedia", "infinite impulse response")}}</strong> (IIR) filter which can be configured to serve as various types of filter.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>iirFilter</em> = <em>AudioContext</em>.createIIRFilter(<em>feedforward</em>, <em>feedback</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>feedforward</code></dt>
 <dd>An array of floating-point values specifying the feedforward (numerator) coefficients for the transfer function of the IIR filter. The maximum length of this array is 20, and at least one value must be nonzero.</dd>
 <dt><code>feedback</code></dt>
 <dd>An array of floating-point values specifying the feedback (denominator) coefficients for the transfer function of the IIR filter. This array may have up to 20 members, the first of which must not be zero.</dd>
</dl>

<h3 id="Description">Return value</h3>

<p>An {{domxref("IIRFilterNode")}} implementing the filter with the specified feedback and feedforward coefficient arrays.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>All of the <code>feedforward</code> coefficients are 0, and/or the first <code>feedback</code> coefficient is 0.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>One or both of the input arrays exceeds 20 members.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-baseaudiocontext-createiirfilter', 'createIIRFilter()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.BaseAudioContext.createIIRFilter")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("IIRFilterNode")}}</li>
 <li>{{domxref("AudioNode")}}</li>
</ul>
